Overview | Modules | Class Hierarchy | Classes | Members

# tlp::NodeLinkDiagramComponent Class Reference

`#include <NodeLinkDiagramComponent.h>`

Inherits tlp::GlMainView.

Inheritance diagram for tlp::NodeLinkDiagramComponent:

[legend]
Collaboration diagram for tlp::NodeLinkDiagramComponent:

[legend]
List of all members.

## Detailed Description

Main view of old Tulip.

This class provide a graph view based to nodes and links Rendering is do with OpenGl

## Public Slots

- void centerView ()
- void drawAfterRenderingParametersChange ()
- virtual void draw ()
- virtual void refresh ()
- virtual void init ()
- void setGraph (Graph *graph)
- void setGraph (Graph *graph, bool initView)
- void elementSelectedSlot (unsigned int id, bool isNode)

## Public Member Functions

- NodeLinkDiagramComponent ()
- virtual ~NodeLinkDiagramComponent ()
- virtual QWidget * construct (QWidget *parent)
- virtual void setData (Graph *graph, DataSet dataSet)
- virtual void getData (Graph **graph, DataSet *dataSet)
- virtual std::list< std::pair<
  QWidget *, std::string > > getConfigurationWidget ()
- virtual void specificEventFilter (QObject *object, QEvent *event)
- virtual void buildContextMenu (QObject *object, QMouseEvent *event, QMenu *contextMenu)
- virtual void computeContextMenuAction (QAction *action)
- void emitRequestChangeGraph (Graph *graph)

## Protected Slots

- void showDialog (QAction *)
- void gridOptions ()

## Protected Member Functions

- void addLayer (tlp::GlScene *, const std::string &, tlp::GlLayer *)
- void modifyLayer (tlp::GlScene *, const std::string &, tlp::GlLayer *)
- void checkAlgorithmResult ()

## Protected Attributes

- QMenu * viewMenu
- QMenu * optionsMenu
- QAction * actionTooltips
- QAction * actionsGridOptions
- QAction * actionZOrderingOptions
- QAction * actionAntialiasingOptions
- QAction * actionTrueMetaNodeOptions
- QAction * augmentedDisplayDialogAction
- QAction * addRemoveAction
- QAction * selectAction
- QAction * deleteAction
- QAction * goAction
- QAction * ungroupAction
- QAction * propAction
- bool isNode
- bool qtMetaNode
- int itemId
- GridOptionsWidget * gridOptionsWidget
- RenderingParametersDialog * renderingParametersDialog
- LayerManagerWidget * layerManagerWidget
- std::map< std::string, DataSet > algorithmInfoDataSet
- GlMetaNodeRenderer * currentMetaNodeRenderer

## Constructor & Destructor Documentation

tlp::NodeLinkDiagramComponent::NodeLinkDiagramComponent | ( |  | ) |

virtual tlp::NodeLinkDiagramComponent::~NodeLinkDiagramComponent | ( |  | ) | `[virtual]`

## Member Function Documentation

void tlp::NodeLinkDiagramComponent::addLayer | ( | tlp::GlScene * | ,
|  | const std::string & | ,
|  | tlp::GlLayer * |
| ) | `[protected, virtual]`

| function call by GlSceneObserver Reimplemented from tlp::GlMainView.

virtual void tlp::NodeLinkDiagramComponent::buildContextMenu | ( | QObject * | object,
|  | QMouseEvent * | event,
|  | QMenu * | contextMenu
| ) | `[virtual]`

| Build context menu for this view Reimplemented from tlp::GlMainView.

void tlp::NodeLinkDiagramComponent::centerView | ( |  | ) | `[slot]`

void tlp::NodeLinkDiagramComponent::checkAlgorithmResult | ( |  | ) | `[protected]`

virtual void tlp::NodeLinkDiagramComponent::computeContextMenuAction | ( | QAction * | action | ) | `[virtual]`

| empty function : implement this function if you have implement buildContextMenu() Reimplemented from tlp::AbstractView.

virtual QWidget* tlp::NodeLinkDiagramComponent::construct | ( | QWidget * | parent | ) | `[virtual]`

Construct this view

Warning:
  If your view inherit of GlMainView you must extend construct function and in this new function call GlMainView::construct(QWidget *)

Reimplemented from tlp::GlMainView.

virtual void tlp::NodeLinkDiagramComponent::draw | ( |  | ) | `[virtual, slot]`

| Draw the OpenGl widget Reimplemented from tlp::GlMainView.

void tlp::NodeLinkDiagramComponent::drawAfterRenderingParametersChange | ( |  | ) | `[slot]`

void tlp::NodeLinkDiagramComponent::elementSelectedSlot | ( | unsigned int | id,
|  | bool | isNode
| ) | `[inline, slot]`

void tlp::NodeLinkDiagramComponent::emitRequestChangeGraph | ( | Graph * | graph | ) | `[inline]`

virtual std::list<std::pair<QWidget *,std::string> > tlp::NodeLinkDiagramComponent::getConfigurationWidget | ( |  | ) | `[virtual]`

| Return configuration widget used, this widget will be add on left of the MainController Reimplemented from tlp::View.

virtual void tlp::NodeLinkDiagramComponent::getData | ( | Graph ** | graph,
|  | DataSet * | dataSet
| ) | `[virtual]`

| Get the graph and data of the view Implements tlp::View.

void tlp::NodeLinkDiagramComponent::gridOptions | ( |  | ) | `[protected, slot]`

virtual void tlp::NodeLinkDiagramComponent::init | ( |  | ) | `[virtual, slot]`

| Reinit the view and draw Implements tlp::View.

void tlp::NodeLinkDiagramComponent::modifyLayer | ( | tlp::GlScene * | ,
|  | const std::string & | ,
|  | tlp::GlLayer * |
| ) | `[protected, virtual]`

| function call by GlSceneObserver Reimplemented from tlp::GlMainView.

virtual void tlp::NodeLinkDiagramComponent::refresh | ( |  | ) | `[virtual, slot]`

| Refresh the OpenGl widget Reimplemented from tlp::GlMainView.

virtual void tlp::NodeLinkDiagramComponent::setData | ( | Graph * | graph,
|  | DataSet | dataSet
| ) | `[virtual]`

| Set the graph and data to the view Implements tlp::View.

void tlp::NodeLinkDiagramComponent::setGraph | ( | Graph * | graph,
|  | bool | initView
| ) | `[slot]`

void tlp::NodeLinkDiagramComponent::setGraph | ( | Graph * | graph | ) | `[virtual, slot]`

| Change the graph Implements tlp::View.

void tlp::NodeLinkDiagramComponent::showDialog | ( | QAction * |  | ) | `[protected, virtual, slot]`

| This slot is call when a QAction in dialog sub menu of context menu is toggle Reimplemented from tlp::GlMainView.

virtual void tlp::NodeLinkDiagramComponent::specificEventFilter | ( | QObject * | object,
|  | QEvent * | event
| ) | `[virtual]`

| empty function : implement this function if you want a specific event filter in your view Reimplemented from tlp::AbstractView.

## Member Data Documentation

QAction* tlp::NodeLinkDiagramComponent::actionAntialiasingOptions `[protected]`

QAction* tlp::NodeLinkDiagramComponent::actionsGridOptions `[protected]`

QAction* tlp::NodeLinkDiagramComponent::actionTooltips `[protected]`

QAction* tlp::NodeLinkDiagramComponent::actionTrueMetaNodeOptions `[protected]`

QAction* tlp::NodeLinkDiagramComponent::actionZOrderingOptions `[protected]`

QAction* tlp::NodeLinkDiagramComponent::addRemoveAction `[protected]`

std::map<std::string,DataSet> tlp::NodeLinkDiagramComponent::algorithmInfoDataSet `[protected]`

QAction* tlp::NodeLinkDiagramComponent::augmentedDisplayDialogAction `[protected]`

GlMetaNodeRenderer* tlp::NodeLinkDiagramComponent::currentMetaNodeRenderer `[protected]`

QAction* tlp::NodeLinkDiagramComponent::deleteAction `[protected]`

QAction* tlp::NodeLinkDiagramComponent::goAction `[protected]`

GridOptionsWidget* tlp::NodeLinkDiagramComponent::gridOptionsWidget `[protected]`

bool tlp::NodeLinkDiagramComponent::isNode `[protected]`

int tlp::NodeLinkDiagramComponent::itemId `[protected]`

LayerManagerWidget* tlp::NodeLinkDiagramComponent::layerManagerWidget `[protected]`

QMenu* tlp::NodeLinkDiagramComponent::optionsMenu `[protected]`

QAction* tlp::NodeLinkDiagramComponent::propAction `[protected]`

bool tlp::NodeLinkDiagramComponent::qtMetaNode `[protected]`

RenderingParametersDialog* tlp::NodeLinkDiagramComponent::renderingParametersDialog `[protected]`

QAction* tlp::NodeLinkDiagramComponent::selectAction `[protected]`

QAction* tlp::NodeLinkDiagramComponent::ungroupAction `[protected]`

QMenu* tlp::NodeLinkDiagramComponent::viewMenu `[protected]`

Tulip Software by LaBRI Visualization Team 2001 - 2010